#include <stddef.h>
#include <stdlib.h>
#include <malloc.h>

#define INCL_WINSWITCHLIST
#define INCL_WINPROGRAMLIST
#define INCL_DOSPROCESS

#include <os2.h>

char writtenby[] = " - Written by Nikolaj Eroshenkov, Oct'1995 - ";

main ()
{
    HAB      hab;
    PSWBLOCK tasklist;
    ULONG    numitems;
    ULONG    tasklistsize;
    PSWCNTRL swcontrol;

    int switchflag;
    int i;

    hab = WinInitialize (0);

    for (;;) {
        numitems = WinQuerySwitchList ( hab, NULL, 0 );
        tasklistsize = (numitems * sizeof(SWENTRY)) + sizeof(HSWITCH);

        tasklist = (SWBLOCK *) malloc ( tasklistsize );

        WinQuerySwitchList ( hab, tasklist, tasklistsize );

        for ( i=0; i<numitems; i++ ) {
            swcontrol = &tasklist->aswentry[i].swctl;
            switchflag = FALSE;

            switch ( swcontrol->bProgType ) {
                case PROG_VDM:
                    if ( swcontrol->fbJump==SWL_NOTJUMPABLE )
                        swcontrol->fbJump = SWL_JUMPABLE,
                        switchflag = TRUE;
                case PROG_FULLSCREEN:
                    if ( swcontrol->uchVisibility==SWL_VISIBLE )
                        swcontrol->uchVisibility = SWL_INVISIBLE,
                        switchflag = TRUE;
                    break;
                case PROG_WINDOWEDVDM:
                    if ( swcontrol->uchVisibility==SWL_INVISIBLE )
                        swcontrol->uchVisibility = SWL_VISIBLE,
                        switchflag = TRUE;
                default:
                    if ( swcontrol->fbJump==SWL_JUMPABLE )
                        swcontrol->fbJump = SWL_NOTJUMPABLE,
                        switchflag = TRUE;
            }
            if ( switchflag==TRUE )
                WinChangeSwitchEntry ( tasklist->aswentry[i].hswitch,
                                       swcontrol );
        }
        free ( tasklist );

        DosSleep ( 1000 );
    }
}
